<?php

namespace WP_SMS\Gateway;

class amootsms extends \WP_SMS\Gateway
{
    private $wsdl_link = "https://portal.amootsms.com/webservice2.asmx/SendSimple_REST";
    public $tariff = "http://amootsms.com/";
        public $unitrial = true;
        public $unit;
        public $flash = "enable";
        public $isflash = false;
    
        public function __construct()
        {
            parent::__construct();
            $this->validateNumber = "09xxxxxxxx";
        }
    
        public function SendSMS()
        {
            
            /**
             * Modify sender number
             *
             * @param string $this ->from sender number.
             *
             * @since 3.4
             *
             */
            $this->from = apply_filters('wp_sms_from', $this->from);
            
            
            /**
             * Modify Receiver number
             *
             * @param array $this ->to receiver number
             *
             * @since 3.4
             *
             */
            $this->to = apply_filters('wp_sms_to', $this->to);
            
            
            /**
             * Modify text message
             *
             * @param string $this ->msg text message.
             *
             * @since 3.4
             *
             */
            $this->msg = apply_filters('wp_sms_msg', $this->msg);
            
            // Get the credit.
            $credit = $this->GetCredit();
            if (is_wp_error($credit)) {
                // Log the result
                $this->log($this->from, $this->msg, $this->to, $credit->get_error_message(), 'error');
    
                return $credit;
            }
            
            
            
            $url = "https://portal.amootsms.com/webservice2.asmx/SendSimple_REST";
            $url = $url."?"."UserName=".$this->username;
            $url = $url."&"."Password=".$this->password;
            
            $nowIran = current_datetime();
            $url = $url."&"."SendDateTime=".$nowIran->format('c');
            
            $url = $url."&"."SMSMessageText=".urlencode($this->msg);
            $url = $url."&"."LineNumber=public";
            $mobiles=json_encode($this->to);
            $mobiles=str_replace('"', '',$mobiles);
            $mobiles=str_replace('[', '',$mobiles);
            $mobiles=str_replace(']', '',$mobiles);
            $url = $url."&"."Mobiles=".$mobiles;
            $response = wp_remote_get($url);
            
            
            // Check gateway credit
            if (is_wp_error($response)) {
                // Log the result
                $this->log($this->from, $this->msg, $this->to, $response->get_error_message(), 'error');
    
                return new \WP_Error('send-sms', $response->get_error_message());
            }
            
            if($response){
                $response_code = wp_remote_retrieve_response_code($response);
                $this->log($this->from, $this->msg, $this->to, $response);
                do_action('wp_sms_send', $response);
                return $response;
            }
            else {
                // Log the result
                $this->log($this->from, $this->msg, $this->to, $response[1], 'error');
    
                return new \WP_Error('account-credit', $response[1]);
            }
            
        }
    
        public function GetCredit()
        {
            // Check username and password
            if (!$this->username && !$this->password) {
                return new \WP_Error('account-credit', __('API username or API password is not entered.', 'wp-sms'));
            }
            
            
            $url = "https://portal.amootsms.com/webservice2.asmx/AccountStatus_REST";
            $url = $url."?"."UserName=".$this->username;
            $url = $url."&"."Password=".$this->password;
            
            $response = wp_remote_get($url);
    

    
            // Check gateway credit
            if (is_wp_error($response)) {
                return new \WP_Error('send-sms', $response->get_error_message());
            }
            // Decode response
            $response = json_decode($response['body']);
            return $response->RemaindCredit;
        }
    }